#ifndef __APP_WINDOW_H__
#define __APP_WINDOW_H__

#include <glib.h>
#include <gtk/gtkwindow.h>
#include <gtk/gtkbox.h>

G_BEGIN_DECLS

#define SLAB_WINDOW_TYPE            (slab_window_get_type ())
#define SLAB_WINDOW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), SLAB_WINDOW_TYPE, SlabWindow))
#define SLAB_WINDOW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), SLAB_WINDOW_TYPE, SlabWindowClass))
#define IS_SLAB_WINDOW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SLAB_WINDOW_TYPE))
#define IS_SLAB_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SLAB_WINDOW_TYPE))
#define SLAB_WINDOW_GET_CLASS(obj)  (G_TYPE_CHECK_GET_CLASS ((obj), SLAB_WINDOW_TYPE, SlabWindowClass))

typedef struct _SlabWindow      SlabWindow;
typedef struct _SlabWindowClass SlabWindowClass;

struct _SlabWindow {
	GtkWindow window;

	GtkBox    *_hbox;
	GtkWidget *_left_pane;
	GtkWidget *_right_pane;
};

struct _SlabWindowClass {
	GtkWindowClass parent_class;
};

GType      slab_window_get_type     (void);
GtkWidget *slab_window_new          (void);
void       slab_window_set_contents (SlabWindow *window, GtkWidget *left_pane, GtkWidget *right_pane);
void       slab_window_reset_contents (SlabWindow *window, GtkWidget *left_pane, GtkWidget *right_pane);

G_END_DECLS

#endif /* __APP_WINDOW_H__ */
