#ifndef __DOUBLE_CLICK_DETECTOR_H__
#define __DOUBLE_CLICK_DETECTOR_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define DOUBLE_CLICK_DETECTOR_TYPE (			\
	double_click_detector_get_type ()		\
)
#define DOUBLE_CLICK_DETECTOR(obj) (			\
	G_TYPE_CHECK_INSTANCE_CAST (			\
		(obj),					\
		DOUBLE_CLICK_DETECTOR_TYPE,		\
		DoubleClickDetector			\
	)						\
)
#define DOUBLE_CLICK_DETECTOR_CLASS(klass) (		\
	G_TYPE_CHECK_CLASS_CAST (			\
		(klass),				\
		DOUBLE_CLICK_DETECTOR_TYPE,		\
		DoubleClickDetectorClass		\
	)						\
)
#define IS_DOUBLE_CLICK_DETECTOR(obj)			\
	(G_TYPE_CHECK_INSTANCE_TYPE (			\
		(obj),					\
		DOUBLE_CLICK_DETECTOR_TYPE		\
	)						\
)
#define IS_DOUBLE_CLICK_DETECTOR_CLASS(klass) (		\
	G_TYPE_CHECK_CLASS_TYPE (			\
		(klass),				\
		DOUBLE_CLICK_DETECTOR_TYPE		\
	)						\
)
#define DOUBLE_CLICK_DETECTOR_GET_CLASS(obj) (		\
	G_TYPE_CHECK_GET_CLASS (			\
		(obj),					\
		DOUBLE_CLICK_DETECTOR_TYPE,		\
		DoubleClickDetectorClass		\
	)						\
)

typedef struct {
	GObject  parent_placeholder;

	guint32 double_click_time;
	guint32 last_click_time;
} DoubleClickDetector;

typedef struct {
	GObjectClass parent_class;
} DoubleClickDetectorClass;

GType double_click_detector_get_type (void);

DoubleClickDetector *double_click_detector_new (void);

gboolean double_click_detector_is_double_click (
	DoubleClickDetector *detector,
	guint32              event_time,
	gboolean             auto_update
);

void double_click_detector_update_click_time (
	DoubleClickDetector *detector,
	guint32              event_time
);

G_END_DECLS

#endif /* __DOUBLE_CLICK_DETECTOR_H__ */
