#ifndef __NETWORK_STATUS_AGENT_H__
#define __NETWORK_STATUS_AGENT_H__

#include <glib-object.h>

#include "network-status-info.h"

G_BEGIN_DECLS

#define NETWORK_STATUS_AGENT_TYPE (                                         \
	network_status_agent_get_type ()                                    \
)
#define NETWORK_STATUS_AGENT(obj) (                                         \
	G_TYPE_CHECK_INSTANCE_CAST (                                        \
		(obj), NETWORK_STATUS_AGENT_TYPE, NetworkStatusAgent        \
	)                                                                   \
)
#define NETWORK_STATUS_AGENT_CLASS(klass) (                                 \
	G_TYPE_CHECK_CLASS_CAST (                                           \
		(klass), NETWORK_STATUS_AGENT_TYPE, NetworkStatusAgentClass \
	)                                                                   \
)
#define IS_NETWORK_STATUS_AGENT(obj) (                                      \
	G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_STATUS_AGENT_TYPE)       \
)
#define IS_NETWORK_STATUS_AGENT_CLASS(klass) (                              \
	G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_STATUS_AGENT_TYPE)        \
)
#define NETWORK_STATUS_AGENT_GET_CLASS(obj) (                               \
	G_TYPE_CHECK_GET_CLASS (                                            \
		(obj), NETWORK_STATUS_AGENT_TYPE, NetworkStatusAgentClass   \
	)                                                                   \
)

typedef struct {
	GObject parent;

	gboolean nm_present;
} NetworkStatusAgent;

typedef struct {
	GObjectClass parent_class;

	void (* status_changed) (NetworkStatusInfo *);
} NetworkStatusAgentClass;

GType network_status_agent_get_type (void);

NetworkStatusAgent *network_status_agent_new (void);

NetworkStatusInfo *network_status_agent_get_first_active_device_info (NetworkStatusAgent *agent);

G_END_DECLS

#endif /* __NETWORK_STATUS_AGENT_H_ */
