#ifndef __NETWORK_STATUS_INFO_H_
#define __NETWORK_STATUS_INFO_H_

#include <glib-object.h>
#include <NetworkManager.h>

G_BEGIN_DECLS

#define NETWORK_STATUS_INFO_TYPE (                                         \
	network_status_info_get_type ()                                    \
)
#define NETWORK_STATUS_INFO(obj) (                                         \
	G_TYPE_CHECK_INSTANCE_CAST (                                       \
		(obj), NETWORK_STATUS_INFO_TYPE, NetworkStatusInfo         \
	)                                                                  \
)
#define NETWORK_STATUS_INFO_CLASS(klass) (                                 \
	G_TYPE_CHECK_CLASS_CAST (                                          \
		(klass), NETWORK_STATUS_INFO_TYPE, NetworkStatusInfoClass  \
	)                                                                  \
)
#define IS_NETWORK_STATUS_INFO(obj) (                                      \
	G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_STATUS_INFO_TYPE)       \
)
#define IS_NETWORK_STATUS_INFO_CLASS(klass) (                              \
	G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_STATUS_INFO_TYPE)        \
)
#define NETWORK_STATUS_INFO_GET_CLASS(obj) (                               \
	G_TYPE_CHECK_GET_CLASS (                                           \
		(obj), NETWORK_STATUS_INFO_TYPE, NetworkStatusInfoClass    \
	)                                                                  \
)

typedef struct {
	GObject parent_placeholder;

	gboolean      active;
	NMDeviceType  type;
	gchar        *iface;
	gchar        *essid;

	gchar        *driver;
	gchar        *ip4_addr;
	gchar        *broadcast;
	gchar        *subnet_mask;
	gchar        *route;
	gchar        *primary_dns;
	gchar        *secondary_dns;
	gint          speed_mbs;
	gchar        *hw_addr;
} NetworkStatusInfo;

typedef struct {
	GObjectClass parent_class;
} NetworkStatusInfoClass;

GType network_status_info_get_type (void);

G_END_DECLS

#endif /* __NETWORK_STATUS_INFO_H_ */
